package com.hai.order.service.impl;

import com.hai.common.exception.ErrorCode;
import com.hai.common.exception.ErrorHelp;
import com.hai.common.exception.SysCode;
import com.hai.entity.*;
import com.hai.order.service.OrderPaySuccessService;
import com.hai.order.service.OrderService;
import com.hai.order.type.OrderChildGoodsType;
import com.hai.service.*;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @className: OrderPaySuccessServiceImpl
 * @author: HuRui
 * @date: 2022/8/29
 **/
@Service("orderPaySuccessService")
public class OrderPaySuccessServiceImpl implements OrderPaySuccessService {

    @Resource
    private OrderService orderService;

    @Resource
    private HighCouponService couponService;

    @Resource
    private HighCouponCodeService couponCodeService;

    @Resource
    private HighOrderPreService orderPreService;

    @Resource
    private HighUserService userService;

    @Override
    public HighOrder orderPaySuccessHandle(HighOrder order) {
        try {
            for (HighChildOrder childOrder : order.getHighChildOrderList()) {
                if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE1.getNumber())) {
                    couponHandle(order, childOrder);

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE2.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE3.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE4.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE5.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE6.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE7.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE8.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE9.getNumber())) {

                } else if (childOrder.getGoodsType().equals(OrderChildGoodsType.TYPE10.getNumber())) {

                }
            }

            return order;

        } catch (Exception e) {
            order.setExceptionStatus(true);
            order.setExceptionContent(e.getMessage());
            orderService.updateOrderData(order);
            throw ErrorHelp.genException(SysCode.System, ErrorCode.COMMON_ERROR, e.getMessage());
        }
    }

    @Override
    public void asyncOrderPaySuccess(HighOrder order) {
        new Thread(() -> {
            orderPaySuccessHandle(order);
        });
    }

    @Override
    public void couponHandle(HighOrder order,HighChildOrder childOrder) throws Exception {
        HighCoupon coupon = couponService.getCouponById(childOrder.getGoodsId());
        // 是否预约
        if (coupon.getReserveStatus()) {
            HighOrderPre orderPre = new HighOrderPre();
            orderPre.setCompanyId(coupon.getCompanyId());
            orderPre.setMerchantId(coupon.getMerchantId());
            orderPre.setMerchantStoreId(childOrder.getStoreId());
            orderPre.setPreOrderNo(System.currentTimeMillis()+"");
            orderPre.setOrderId(order.getId());
            orderPre.setOrderNo(order.getOrderNo());
            orderPre.setChildOrderId(childOrder.getId());
            orderPre.setPayRealPrice(order.getPayRealPrice());
            orderPre.setGoodsType(1);
            orderPre.setGoodsName(coupon.getCouponName());
            orderPre.setGoodsId(coupon.getId());
            orderPre.setPreUserId(order.getMemId());
            orderPre.setPreUserName(order.getMemName());
            orderPre.setPreUserPhone(order.getMemPhone());
            orderPre.setPreUserRemark(order.getRemarks());
            orderPre.setStatus(1);
            orderPreService.insertOrderPre(orderPre);
        }

        // 支付购买卡券
        couponCodeService.payCoupon(order,childOrder,coupon);

    }

    @Override
    public void integralRecharge(HighOrder order,HighChildOrder childOrder) {
        // 金币 1：100
        Integer goldNum = new BigDecimal(childOrder.getTotalPrice().toString()).multiply(new BigDecimal("100")).intValue();
        String remark = "订单" + order.getOrderNo() + "积分充值积分：" +  goldNum;
        userService.goldHandle(childOrder.getGoodsId(), goldNum, 1, 1, childOrder.getId() , remark);
    }
}
